exec("./maze.cs");
exec("./perlin.cs");

function ZG_Reload()
{
	exec("./server.cs");
}

function ZG_PlantBrick(%position, %datablock, %zlock, %angle, %colour, %colorFX, %forceType, %shapeFX, %disablecollision, %rotation)
{
	if(!isObject(%datablock))
	{
		echo("Please specify a valid datablock!");
		return;
	}
	
	%posx = getWord(%position, 0);
	%posy = getWord(%position, 1);
	%posz = getWord(%position, 2);
	
	if(%forceType == 1)
	{
		%posx = brickToMetric(4 * %posx);
		%posy = brickToMetric(4 * %posy);
	}
	else if(%forceType == 2)
	{
		%posx = brickToMetric(12 * %posx);
		%posy = brickToMetric(6 * %posy);
	}
	else if(%forceType == 3)
	{
		%posx = brickToMetric(12 * %posx + 2);
		%posy = brickToMetric(6 * %posy);
	}
	else if(%forceType == 4)
	{
		%posx = brickToMetric(12 * %posx + 2);
		%posy = brickToMetric(6 * %posy + 4);
	}
	else if(%forceType == 5)
	{
		%posx = brickToMetric(12 * %posx + 2);
		%posy = brickToMetric(6 * %posy - 4);
	}
	else if(%forceType == 6)
	{
		%posx = brickToMetric(12 * %posx - 6);
		%posy = brickToMetric(6 * %posy);
	}
	else if(%forceType == 7)
	{
		%posx = brickToMetric(6 * %posx);
		%posy = brickToMetric(6 * %posy);
	}
	else if(%forceType == 666)
	{
		%posx = getWord(%position, 0);
		%posy = getWord(%position, 1);
		%posz = getWord(%position, 2);
	}
	else
	{
		%posx = brickToMetric(%datablock.brickSizeX * %posx);
		%posy = brickToMetric(%datablock.brickSizeY * %posy);
	}
	
	if(%zlock)
	{
		%posz = %posz + 13;
		%posz = brickToMetric(%posz);
		%posz = %datablock.brickSizeZ * %posz / 2.50;
		%poszminus = %datablock.brickSizeZ * 2.50;
		%posz = %posz - %poszminus;
	}
	
	%brick = new fxDTSBrick()
	{
		datablock = %datablock;
		position = %posx SPC %posy SPC %posz;
		colorID = %colour;
		angleID = %angle;
		colorfxID = %colorFX;
		isPlanted = 1;
		shapefxID = %shapeFX;
		rotation = %rotation;
		stackBL_ID = 888888;
	};
	//echo(%posx SPC %posy SPC %posz);
	%brick.setTrusted(1);
	%brick.setColliding(!%disablecollision);
	%brick.plant();
	BrickGroup_888888.add(%brick);
}

function ZG_PlantTower(%position, %datablock, %angle, %colour, %colorFX)
{
	if(!isObject(%datablock))
	{
		echo("Please specify a valid datablock!");
		return;
	}
	%position = getWord(%position, 0) SPC getWord(%position, 1);
	for(%a = 0; %a < 50; %a++)
	{
		ZG_PlantBrick(%position SPC %a, %datablock, true, %angle, %colour, %colorFX);
	}
}

function ZG_PlantBetterTerrain(%size)
{
	%width = %size;
	%length = %size;
	
	%px = 0;
	%py = 0;
	%pz = 0;
	if(!%iters)
		%iters = 4;
	%perlin = new ScriptObject()
		{
			class = perlin;
		};
	%size = %width * %length;
	%quality = 2;
	%z = 0;
	
	for(%j=0;%j<%iters;%j++)
	{
		for(%i=0;%i<%size;%i++)
		{
			if(%data[%i] $= "")
				%data[%i] = 0;
			%x = %i % %width;
			%y = mFloor(%i / %length);
			%data[%i] = %perlin.noise(%x / %quality,%y / %quality,%z) * %quality;
		}
		%quality *= 4;
	}
	
	for(%x=0;%x<%width;%x++)
	{
		for(%y=0;%y<%length;%y++)
		{
			%bx = %px + (%x * 2);
			%by = %py + (%y * 2);
			%bz = %pz + mFloor(%data[%x + %y * %width] * 0.2);
			%bpos = %bx SPC %by SPC %bz;
			%brick = new fxDTSBrick()
			{
				position = %bpos;
				datablock = brick4xCubeData;
				isPlanted = 1;
				colorID = 2;
				stackBL_ID = 888888;
			};
			%brick.setTrusted(1);
			%brick.plant();
			BrickGroup_888888.add(%brick);
		}
	}
	
	%perlin.delete();
}

function ZG_PlantTerrain(%size)
{
	if(%size < 5)
	{
		%size = 5;
	}
	
	$ZG_CurrentTerrainSize = %size;
	
	for(%a = 0; %a < %size / 2; %a++)
	{
		ZG_PlantTerrainPeice(0 SPC %a);
		for(%b = 1; %b < %size / 2; %b++)
		{
			ZG_PlantTerrainPeice(%b SPC %a);
		}
		for(%c = -1; %c > %size / 2 - %size; %c--)
		{
			ZG_PlantTerrainPeice(%c SPC %a);
		}
	}
	
	for(%a = -1; %a > %size / 2 - %size; %a--)
	{
		ZG_PlantTerrainPeice(0 SPC %a);
		for(%b = 1; %b < %size / 2; %b++)
		{
			ZG_PlantTerrainPeice(%b SPC %a);
		}
		for(%c = -1; %c > %size / 2 - %size; %c--)
		{
			ZG_PlantTerrainPeice(%c SPC %a);
		}
	}
}

function ZG_GetTerrainHeight(%xy)
{
	//echo("Created terrain block at" SPC %xy);
	%max = mCeil($ZG_CurrentTerrainSize / 2);
	%antimax = %max * 2;
	%antimax = %max - %antimax;
	%qqmax = %max / 8;
	
	%x = getWord(%xy, 0);
	%y = getWord(%xy, 1);
	
	if(%x < 0)
	{
		%negativex = true;
	}
	
	if(%y < 0)
	{
		%negativey = true;
	}
	
	if(!%negativex && %x == %max - 1 || !%negativey && %y == %max - 1)
	{
		%random = getRandom(0, 15);
		if(%random < 3)
		{
			%isWater = false;
		}
		else
		{
			%isWater = false;
		}
		return 1 SPC %isWater;
	}
	
	if(%negativex && %x == %antimax + 1 || %negativey && %y == %antimax + 1)
	{
		%random = getRandom(0, 15);
		if(%random < 12)
		{
			%isWater = false;
		}
		else
		{
			%isWater = false;
		}
		return 1 SPC %isWater;
	}
	
	if(%negativex || %negativey)
	{
		%groundchancex = getRandom(%x, %antimax);
		%groundchancey = getRandom(%y, %antimax);
		
		if(%groundchancex < %antimax + %qqmax || %groundchancey < %antimax + %qqmax)
		{
			%random = getRandom(0, 15);
			if(%random < 9)
			{
				%isWater = false;
			}
			else
			{
				%isWater = false;
			}
			return 1 SPC %isWater;
		}
	}
	
	if(!%negativex || !%negativey)
	{
		%groundchancex = getRandom(%x, %max);
		%groundchancey = getRandom(%y, %max);
		
		if(%groundchancex > %max - %qqmax || %groundchancey > %max - %qqmax)
		{
			%random = getRandom(0, 15);
			if(%random < 9)
			{
				%isWater = false;
			}
			else
			{
				%isWater = false;
			}
			return 1 SPC %isWater;
		}
	}
	
	%a = getRandom(1, 1.5);
	%a = %a @ "." @ getRandom(1, 9);
	return %a;
}

function ZG_PlantTerrainPeice(%xy)
{
	%datablock = Brick4xCubeData;
	%grassdatablock = Brick4x4fData;
	%treedatablock = BrickPineTreeData;
	
	%random = ZG_GetTerrainHeight(%xy);
	%isWater = getWord(%random, 1);
	%random = getWord(%random, 0);
	
	ZG_PlantBrick(%xy SPC %random, %datablock, false, 0, 8, 0);
	
	if(%isWater)
	{
		ZG_PlantBrick(%xy SPC %random + 1, %grassdatablock, false, 0, 33, 0, false, 2, true);
	}
	else
	{
		ZG_PlantBrick(%xy SPC %random + 1, %grassdatablock, false, 0, 2, 0);
	}
	
	if(!%isWater && getRandom(1, 25) == 10)
	{
		schedule(50, 0, ZG_PlantBrick, %xy SPC %random + 3.5, %treedatablock, false, 0, 2, 0, true);
	}
}

function ZG_PlantBetterTerrainPeice(%pos)
{
	%datablock = Brick4xCubeData;
	%grassdatablock = Brick4x4fData;
	%treedatablock = BrickPineTreeData;
	
	ZG_PlantBrick(%pos, %datablock, false, 0, 8, 0, 666);
	
	ZG_PlantBrick(%pos, %grassdatablock, false, 0, 2, 0, 666);
	
	if(getRandom(1, 25) == 1)
	{
		schedule(50, 0, ZG_PlantBrick, %pos, %treedatablock, false, 0, 2, 0, 666);
	}
}

function ZG_PlantMaze()
{
	ZG_GenerateMaze();
}

function ZG_PlantMazeSpawn()
{
	ZG_PlantBrick("-1 0 1.66", Brick2x4x5Data, false, 0, 6, 0, 0, 0, 0, "0 0 1 90");
	ZG_PlantBrick("-1 3 1.66", Brick2x4x5Data, false, 0, 6, 0, 0, 0, 0, "0 0 1 90");
	ZG_PlantBrick("-0.25 0 1.66", Brick1x2x5Data, false, 0, 6, 0, 0, 0, 0, "0 0 1 0");
	ZG_PlantBrick("-0.25 6 1.66", Brick1x2x5Data, false, 0, 6, 0, 0, 0, 0, "0 0 1 0");
	
	ZG_PlantBrick("-3 0 1.66", Brick2x4x5Data, false, 0, 6, 0, 0, 0, 0, "0 0 1 90");
	ZG_PlantBrick("-3 3 1.66", Brick2x4x5Data, false, 0, 6, 0, 0, 0, 0, "0 0 1 90");
	ZG_PlantBrick("-4.5 0 1.66", Brick2x2x5Data, false, 0, 5, 0, 0, 0, 0, "0 0 1 90");
	ZG_PlantBrick("-4.5 6 1.66", Brick2x2x5Data, false, 0, 5, 0, 0, 0, 0, "0 0 1 90");
	ZG_PlantBrick("-1.5 0 0", Brick6x6fData, true, 0, 5, 0, 7, 0, 0, "0 0 1 0");
	ZG_PlantBrick("-1.5 1 0", Brick6x6fData, true, 0, 5, 0, 7, 0, 0, "0 0 1 0");
	ZG_PlantBrick("-1.5 2 0", Brick6x6fData, true, 0, 5, 0, 7, 0, 0, "0 0 1 0");
	ZG_PlantBrick("-1.5 0 16", Brick6x6fData, true, 0, 5, 0, 7, 0, 0, "0 0 1 0");
	ZG_PlantBrick("-1.5 1 16", Brick6x6fData, true, 0, 5, 0, 7, 0, 0, "0 0 1 0");
	ZG_PlantBrick("-1.5 2 16", Brick6x6fData, true, 0, 5, 0, 7, 0, 0, "0 0 1 0");
	
	ZG_PlantBrick("-3.3 0.99 0", Brick16x32fData, true, 0, 5, 0, 7, 0, 0, "0 0 1 0");
	ZG_PlantBrick("-3.3 0.99 16", Brick16x32fData, true, 0, 5, 0, 7, 0, 0, "0 0 1 0");
	ZG_PlantBrick("-5.5 3.33 1.66", Brick2x4x5Data, false, 0, 6, 0, 0, 0, 0, "0 0 1 0");
	ZG_PlantBrick("-5.5 -0.25 1.66", Brick2x4x5Data, false, 0, 6, 0, 0, 0, 0, "0 0 1 0");
	ZG_PlantBrick("-5.5 4.33 1.66", Brick2x4x5Data, false, 0, 6, 0, 0, 0, 0, "0 0 1 0");
	ZG_PlantBrick("-5.5 -1.25 1.66", Brick2x4x5Data, false, 0, 6, 0, 0, 0, 0, "0 0 1 0");
	ZG_PlantBrick("-6 -2 1.66", Brick2x4x5Data, false, 0, 6, 0, 0, 0, 0, "0 0 1 90");
	ZG_PlantBrick("-6 5 1.66", Brick2x4x5Data, false, 0, 6, 0, 0, 0, 0, "0 0 1 90");
	ZG_PlantBrick("-8 -2 1.66", Brick2x4x5Data, false, 0, 6, 0, 0, 0, 0, "0 0 1 90");
	ZG_PlantBrick("-10 -2 1.66", Brick2x4x5Data, false, 0, 6, 0, 0, 0, 0, "0 0 1 90");
	ZG_PlantBrick("-8 5 1.66", Brick2x4x5Data, false, 0, 6, 0, 0, 0, 0, "0 0 1 90");
	ZG_PlantBrick("-10 5 1.66", Brick2x4x5Data, false, 0, 6, 0, 0, 0, 0, "0 0 1 90");
	ZG_PlantBrick("-11.5 -1.66 1.66", Brick2x4x5Data, false, 0, 6, 0, 0, 0, 0, "0 0 1 0");
	ZG_PlantBrick("-11.5 -0.66 1.66", Brick2x4x5Data, false, 0, 6, 0, 0, 0, 0, "0 0 1 0");
	ZG_PlantBrick("-11.5 0.33 1.66", Brick2x4x5Data, false, 0, 6, 0, 0, 0, 0, "0 0 1 0");
	ZG_PlantBrick("-11.5 1.33 1.66", Brick2x4x5Data, false, 0, 6, 0, 0, 0, 0, "0 0 1 0");
	ZG_PlantBrick("-11.5 2.33 1.66", Brick2x4x5Data, false, 0, 6, 0, 0, 0, 0, "0 0 1 0");
	ZG_PlantBrick("-11.5 3.33 1.66", Brick2x4x5Data, false, 0, 6, 0, 0, 0, 0, "0 0 1 0");
	ZG_PlantBrick("-11.5 4.33 1.66", Brick2x4x5Data, false, 0, 6, 0, 0, 0, 0, "0 0 1 0");
	ZG_PlantBrick("-11.5 10 1.66", Brick2x2x5Data, false, 0, 6, 0, 0, 0, 0, "0 0 1 0");
	ZG_PlantBrick("-6.66 -1.66 1.66", BrickSpawnPointData, false, 0, 6, 0, 0, 0, 0, "0 0 1 90");
	ZG_PlantBrick("-6.66 -0.66 1.66", BrickSpawnPointData, false, 0, 6, 0, 0, 0, 0, "0 0 1 90");
	ZG_PlantBrick("-6.66 0.33 1.66", BrickSpawnPointData, false, 0, 6, 0, 0, 0, 0, "0 0 1 90");
	ZG_PlantBrick("-6.66 1.33 1.66", BrickSpawnPointData, false, 0, 6, 0, 0, 0, 0, "0 0 1 90");
	ZG_PlantBrick("-6.66 2.33 1.66", BrickSpawnPointData, false, 0, 6, 0, 0, 0, 0, "0 0 1 90");
	ZG_PlantBrick("-6.66 3.33 1.66", BrickSpawnPointData, false, 0, 6, 0, 0, 0, 0, "0 0 1 90");
	ZG_PlantBrick("-6.66 4.33 1.66", BrickSpawnPointData, false, 0, 6, 0, 0, 0, 0, "0 0 1 90");
	ZG_PlantBrick("-6.66 5.33 1.66", BrickSpawnPointData, false, 0, 6, 0, 0, 0, 0, "0 0 1 90");
	ZG_PlantBrick("-5.66 -1.66 1.66", BrickSpawnPointData, false, 0, 6, 0, 0, 0, 0, "0 0 1 90");
	ZG_PlantBrick("-5.66 -0.66 1.66", BrickSpawnPointData, false, 0, 6, 0, 0, 0, 0, "0 0 1 90");
	ZG_PlantBrick("-5.66 0.33 1.66", BrickSpawnPointData, false, 0, 6, 0, 0, 0, 0, "0 0 1 90");
	ZG_PlantBrick("-5.66 1.33 1.66", BrickSpawnPointData, false, 0, 6, 0, 0, 0, 0, "0 0 1 90");
	ZG_PlantBrick("-5.66 2.33 1.66", BrickSpawnPointData, false, 0, 6, 0, 0, 0, 0, "0 0 1 90");
	ZG_PlantBrick("-5.66 3.33 1.66", BrickSpawnPointData, false, 0, 6, 0, 0, 0, 0, "0 0 1 90");
	ZG_PlantBrick("-5.66 4.33 1.66", BrickSpawnPointData, false, 0, 6, 0, 0, 0, 0, "0 0 1 90");
	ZG_PlantBrick("-5.66 5.33 1.66", BrickSpawnPointData, false, 0, 6, 0, 0, 0, 0, "0 0 1 90");
	ZG_PlantBrick("-4.66 -1.66 1.66", BrickSpawnPointData, false, 0, 6, 0, 0, 0, 0, "0 0 1 90");
	ZG_PlantBrick("-4.66 -0.66 1.66", BrickSpawnPointData, false, 0, 6, 0, 0, 0, 0, "0 0 1 90");
	ZG_PlantBrick("-4.66 0.33 1.66", BrickSpawnPointData, false, 0, 6, 0, 0, 0, 0, "0 0 1 90");
	ZG_PlantBrick("-4.66 1.33 1.66", BrickSpawnPointData, false, 0, 6, 0, 0, 0, 0, "0 0 1 90");
	ZG_PlantBrick("-4.66 2.33 1.66", BrickSpawnPointData, false, 0, 6, 0, 0, 0, 0, "0 0 1 90");
	ZG_PlantBrick("-4.66 3.33 1.66", BrickSpawnPointData, false, 0, 6, 0, 0, 0, 0, "0 0 1 90");
	ZG_PlantBrick("-4.66 4.33 1.66", BrickSpawnPointData, false, 0, 6, 0, 0, 0, 0, "0 0 1 90");
	ZG_PlantBrick("-4.66 5.33 1.66", BrickSpawnPointData, false, 0, 6, 0, 0, 0, 0, "0 0 1 90");
}

function ZG_PlantMazePhase2()
{
	ZG_PlantMazeSpawn();
	
	%size = 50;
	
	%file = new fileObject();
	%file.openForRead("config/server/maze.dat");
	while(!%file.isEOF())
	{
		%line = %file.readLine();
		if(%mazeFile $= "")
		{
			%mazeFile = %line;
		}
		else
		{
			%mazeFile = %mazeFile NL %line;
		}
	}
	%file.close();
	%file.delete();
	
	for(%a = 0; %a < %size; %a++)
	{
		ZG_PlantMazePeice(0 SPC %a, %mazeFile);
		for(%b = 1; %b < %size; %b++)
		{
			ZG_PlantMazePeice(%b SPC %a, %mazeFile);
		}
	}
	
	echo("Built maze successfully.");
	announce("\c6Generated maze successfully.");
}

function ZG_PlantMazePeice(%xy, %mazeFile)
{
	%row = getWord(%xy, 0);
	%column = getWord(%xy, 1);
	
	%peice = getLine(%mazeFile, %row);
	%peice = getSubStr(%peice, %column, 1);
	
	if(%peice !$= "")
	{
		ZG_PlantBrick(%xy SPC 0, Brick6x12fData, true, 0, 5, 0, 2, 0, 0, "0 0 1 90");
		ZG_PlantBrick(%xy SPC 16, Brick6x12fData, true, 0, -1, 0, 2, 0, 0, "0 0 1 90");
	}
	
	if(%peice $= "_")
	{
		ZG_PlantBrick(%xy SPC 1.66, Brick2x6x5Data, false, 0, 6, 0, 3, 0, 0, "0 0 1 0");
		ZG_PlantBrick(%xy SPC 1.66, Brick2x2x5Data, false, 0, 6, 0, 4, 0, 0, "0 0 1 0");
		ZG_PlantBrick(%xy SPC 1.66, Brick2x2x5Data, false, 0, 6, 0, 5, 0, 0, "0 0 1 0");
	}
	
	if(%peice $= ".")
	{
		ZG_PlantBrick(%xy SPC 1.66, Brick2x2x5Data, false, 0, 5, 0, 3, 0, 0, "0 0 1 0");
	}
	
	if(%peice $= "|")
	{
		ZG_PlantBrick(%xy SPC 1.66, Brick2x6x5Data, false, 0, 6, 0, 2, 0, 0, "0 0 1 90");
		ZG_PlantBrick(%xy SPC 1.66, Brick2x6x5Data, false, 0, 6, 0, 6, 0, 0, "0 0 1 90");
	}
}

function ZG_GenerateMaze()
{
	echo("Generating maze...");
	announce("\c6Generating maze...");
	if(isObject(ZG_MazeHost))
	{
		ZG_MazeHost.delete();
	}
	
	%this = new TCPObject(ZG_MazeHost);
	
	%this.mazeData = "";
	%this.connect("zapkraft.netne.net:80");
	BrickGroup_888888.chainDeleteAll();
}

function ZG_MazeHost::onConnected(%this)
{
    %this.send("GET /maze.php	HTTP/1.0\r\nHost: zapkraft.netne.net\r\n\r\n");
}

function ZG_MazeHost::onLine(%this,%line)
{
	if(getSubStr(%line, 0, 1) !$= "." && getSubStr(%line, 0, 1) !$= "|")
	{
		return;
	}
	if(%this.mazeData $= "")
	{
		%this.mazeData = %line;
	}
	else
	{
		%this.mazeData = %this.mazeData NL %line;
	}
}

function ZG_MazeHost::onDisconnect(%this)
{
	echo("Generated maze.");
	echo("Building maze...");
	%file = new fileObject();
	%file.openForWrite("config/server/maze.dat");
	for(%a = 0; %a <= getLineCount(%this.mazeData); %a++)
	{
		%file.writeLine(getLine(%this.mazeData, %a));
	}
	%file.close();
	%file.delete();
	
	ZG_PlantMazePhase2();
}